100 REMark PC Sample converter for I2C Analogue output
110 REMark By Simon N Goodwin; NOT for compressed samples
120 REMark Extensions: I2C_IO (TF Services), FLEN (PDTk/Tk2)
130 REMark INPUT$ & SET_POS (DIY Toolkit Volume E)
140 :
150 REMark REPLAY "ram1_Whistle"
160 REPLAY "ram1_Lion"
170 REPLAY "ram1_CarSkid"
180 REPLAY "ram1_Trumpet"
195 CONVERT_WAV
197 PAUSE : GRAPH
200 STOP
210 :
220 DEFine PROCedure GRAPH
230 REMark Graphs sample in K$
240 REMark in 1K pages, 2 deep
250 OPEN #3,scr_512x256a0x0
260 CLS #3
270 FOR i=1 TO LEN(k$)
280   BLOCK #3,1,1,i && 511,CODE(k$(i)),7
290   IF i MOD 1024=0 : CLS #3
300 END FOR i
310 CLOSE #3
320 END DEFine GRAPH
330 :
340 DEFine PROCedure REPLAY(n$)
350 REMark replays samples up to about 32K long
360 REMark from disk onto DAC channel 1
370 REMark Uses FLEN and INPUT$
380 REMark LOCal k$,t
390 OPEN_IN #3,n$
400 k$=INPUT$(#3,FLEN(#3))
410 CLOSE #3
420 t=WRITE_adc%(1,k$)
440 END DEFine
450 :
460 DEFine PROCedure CONVERT_WAV
470 REMark Convert PC samples
480 REMark to I2C unsigned format
490 REMark Uses FLEN, INPUT$ & SET_POS
500 max=32750 : ok=0
505 CLS : CSIZE 2,0
507 PRINT "Uncompressed .WAV file converter v1.0"
508 CSIZE 1,0
510 REMark n$="flp2_LionRoar"
520 INPUT \"Enter PC sample file name [.WAV] ";n$
530 IF n$="" : STOP
540 IF 0=".WAV" INSTR n$ : n$=n$ & ".WAV"
550 OPEN_IN #3,n$
560 IF INPUT$(#3,4)="RIFF"
570 REMark Check for PC .WAV header
580   length=CODE(INKEY$(#3,-1))+256*CODE(INKEY$(#3,-1))
590   length=length+65536*(CODE(INKEY$(#3,-1))+256*CODE(INKEY$(#3,-1)))
600   IF length+8=FLEN(#3)
610     PRINT "RIFF file length ";length;
620     IF INPUT$(#3,8)="WAVEfmt "
630       PRINT " in WAVE format"
640       IF length>max
650         PRINT "Truncating file to " & max & " bytes"
660         length=max+36
670       END IF
680       SET_POS #3,44
690       k$=INPUT$(#3,length-36)
700       ok=1 :REMark It worked
710     ELSE
720       PRINT " in unrecognised format."
730     END IF
740   ELSE
750     PRINT "Length does not match header."
760   END IF
770 ELSE
780   PRINT #0;"Sample is not a PC RIFF file."
790 END IF
800 CLOSE #3
810 IF ok
820   INPUT \"Enter new QL sample file name ";n$
830   IF LEN(n$)
840     OPEN_NEW #3,n$
850     PRINT #3,k$;
860     CLOSE #3
870   END IF
880   PRINT \"OK, converted sample is in K$"
890 END IF
900 END DEFine CONVERT_WAV
910 :
920 REMark non-zero error code on error
930 REMark $$external
940 DEFine FuNction WRITE_adc%(ADDRESS,x$):LOCal addr%
950  addr%=test_adc_addr%(ADDRESS):IF addr%<0:RETurn addr%
960  RETurn CODE(I2C_IO(CHR$(160)&CHR$(68)&x$&CHR$(255),0,addr%,x$(0)+1))
970  REMark 160 is send START+device, write from control buffer (length LEN(x$)+1 is preset)
980  REMark 68 is the ADC control byte
990  REMark x$ is the string itself
1000  REMark 255 is the standard finish
1010  END DEFine
1020 :
1030 DEFine FuNction test_adc_addr%(a):RETurn test_addr%(a,72):END DEFine
1040 :
1050 DEFine FuNction test_addr%(a,m%):LOCal a%:IF isnum%(a)
1060   IF NOT inrange%(0,a,127):RETurn -4:REMark out of range
1070   IF INT(a)=a
1080    a%=a&&-8:SELect a%=0,m%:RETurn m%||a:REMark OK
1090    RETurn -7:REMark not found
1100    END IF :END IF :RETurn -15:END DEFine
1110 REMark ret non-zero if parameter is not valid floating point
1120 DEFine FuNction isnum%(p):LOCal a$,b$,e$,lp,i:a$=p:REMark only unset will cause a problem
1130  IF a$(0)>1:IF a$(1)INSTR'+-':a$=a$(2TO):REMark accept sign+sommat
1140  e$='0':i='e'INSTR a$:SELect i=2TO a$(0)-2:e$=a$(i+1TO):a$=a$(1TO i-1):IF e$(0)>1:IF e$(1)INSTR'+-':e$=e$(2TO):REMark accept sensible, optionally signed exponent
1150  b$='0':IF a$(0)>1:i='.'INSTR a$:SELect i=1:b$=a$(2TO):a$='0':=a$(0):a$=a$(1TO a$(0)-1):=1TO a$(0):b$=a$(i+1TO):a$=a$(1TO i-1):REMark accept mantissa with sensible, optional decimal point
1160  a$=a$&b$&e$:REMark recombine parts
1170  FOR i=1TO a$(0):IF (CODE(a$(i))-48)DIV 10:RETurn 0:REMark reject any non-digits left
1180  RETurn e$<550AND a$(0):END DEFine :REMark not being too pedantic about huge exponents
1190 :
1200 DEFine FuNction inrange%(scan,v,h):RETurn scan<=v AND v<=h:END DEFine
